'* TEST SETUP RDA5807SP  ATM32 8Mhz int
' setup freqvence via serial 9600 baud  as mhz  XXX.X   my test 104.7
' http://www.ebay.com/itm/Rda5807-FM-Stereo-LOW-IF-Digital-Radio-Module-DIY-For-MP3-MP4-Player-I2C-SPI-NEW-/251054020079?pt=LH_DefaultDomain_0&hash=item3a73fc55ef
' http://www.marcmart.net/2012/02/29/rda5807-fm-stereo-low-if-digital-radio-module-diy-for-mp3mp4-player-i2c-spi-new-ot275/
$regfile = "m32def.dat"
$crystal = 8000000
$hwstack = 128
$swstack = 128
$framesize = 128
'Disable the JTAG ONLY M32
Set Mcucsr.7
Set Mcucsr.7

Config Single = Scientific , Digits = 1
Dim Pll As Single
Dim Fset As Word

Dim Input_freq As Single
Dim Freq_high As Byte
Dim Freq_low As Byte
Dim Register As Byte
Dim Data_1 As Byte
Dim Data_2 As Byte

Declare Sub Set_freq()


Config Scl = Portc.0
Config Sda = Portc.1
Config Portc.3 = Input
Config Portc.3 = Input
Portc.3 = 1
Portc.4 = 1
Const Freq_ref = 32.768
Const Freq_g = 225
Const Factor = 4
I2cinit
Waitms 200
'power on test setup 104.7 Mhz
Input_freq = 104.7
Call Set_freq()
Enable Interrupts


Do
 'freq UP step +0.1 Mhz
 If Pinc.3 = 0 Then
   Input_freq = Input_freq + 0.1
   If Input_freq > 108 Then Input_freq = 87.5
   Call Set_freq()
   Waitms 150
 End If
  'freq DOWN step -0.1 Mhz
 If Pinc.4 = 0 Then
  Input_freq = Input_freq - 0.1
  If Input_freq < 87.5 Then Input_freq = 108.0
  Call Set_freq()
  Waitms 150
 End If

Loop
End

Sub Set_freq()
   Pll = Input_freq * 1000
   Pll = Pll + Freq_g
   Pll = Pll * Factor
   Pll = Pll / Freq_ref
   Fset = Int(pll)
   Freq_high = High(fset)
   Reset Freq_high.7
   Reset Freq_high.6
   Freq_low = Low(fset)
   Register = &B00010000
   Data_1 = &B00110010
   Data_2 = &B00000000
   I2cstart
   I2cwbyte &HC0
   I2cwbyte Freq_high
   I2cwbyte Freq_low
   I2cwbyte Register
   I2cwbyte Data_1
   I2cwbyte Data_2
   I2cstop
End Sub


